<template>
	<div class="planilas-container">
		<el-card shadow="always" v-for="v in listaRecursos" :key="v.id"
			@dragover.native.prevent @drop.native="drop($event, v.id)"  
			class="card"  :style="{background: v.estadoMovil == 'Ocupado' ? '#F56C6C70' : '#67C23A70'}"
			@mouseenter.native="itemHover = v.id"
			@mouseleave.native="itemHover = null">
			<el-row>
				<label>Movil</label>
				<span>{{v.movil}}</span>
				<span v-if="v.origenLocalidad">({{v.origenLocalidad}})</span>
			</el-row>
			<el-divider></el-divider>
			<el-row>
				<label>Estado</label>
				<span>{{v.estadoMovil}}</span>
			</el-row>
			<div class="buttons" v-if="itemHover == v.id" >
				<el-button type="primary" icon="el-icon-edit" size="mini" circle @click.native="editarPlanilla(v)"></el-button>
			</div>
		</el-card>
		<el-dialog title="Planilla" :visible.sync="dialogoPlanilla" width="90%" destroy-on-close>
			<form-planilla v-if="dialogoPlanilla"
				:idPlanilla="idPlanilla"
				@submit="dialogoPlanilla = false" @cancel="dialogoPlanilla=false"
				/>
		</el-dialog>
		<el-dialog title="Despachar Viaje" :visible.sync="dialogoDespacho" destroy-on-close>
			<despachar v-if="dialogoDespacho" @submit="dialogoDespacho = false" :idViaje.sync="idViaje" :idPlanilla="idPlanilla"/>
		</el-dialog>

	</div>
	
</template>
<script>
import store from '@/store/planillas'
import storeViajes from '@/store/viajes'
// import Rest from '@/../vendor/mind-core-web/src/lib/rest'
import {Rest} from '@/../vendor/mind-core-web/'
import formPlanilla from './form-planilla'
import despachar from './viaje-despachar'


export default {
	components: {
		formPlanilla,
		despachar
	},
	props: {
		/**
		 * Indica que solo de deben mostrar los móviles en estado especificado
		 */
		estado: String,
	},
	created(){
		store.idAgencia = 1

		this.api = new Rest({
			uri: `/api/viajes/agencias/${store.idAgencia}/planillas`, 
			state: store.data,
			key: 'id'})
		this.fetch()
	},
	computed: {
		listaRecursos() {

			return store.data.RESOURCE_LIST.filter(p => !this.estado || p.estadoMovil == this.estado).sort((a,b)=>{
					if(a.estadoMovil == b.estadoMovil) {
							return 0
					}
					if(a.estadoMovil == 'Ocupado') {
							return 1
					}
					return -1

			})
		},
		listaViajes() {
			return storeViajes.data.RESOURCE_LIST
		}
	},
	watch:{
		//observo cambios en la lista de viajes para actualizar la lista de planillas
		listaViajes() {
			this.fetch()
		}
		// store.data.RESOURCE_LIST
	},
	methods: {
		fetch() {
			this.api.FetchAll({
				filters:{
					estado: 'Abierta',
				},
				sort:['ts_update']
			}).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})

		},
		editarPlanilla(planilla) {
			this.$router.push(`/planillas/${planilla.id}`)
			// this.idPlanilla = planilla.id
			// this.dialogoPlanilla = true;
		},
		nuevaPlanilla() {
			this.idPlanilla = null
			this.dialogoPlanilla = true;
		},
		dragStart(event, idPlanilla) {
			event.dataTransfer.setData('idPlanilla', idPlanilla)
		},
		drop(event, idPlanilla) {
			const idViaje = event.dataTransfer.getData('idViaje')
			if(!idPlanilla || !idViaje) {
				return
			}
			this.idViaje = idViaje
			this.idPlanilla = idPlanilla
			this.dialogoDespacho = true
		},
	},
	data(){
		return{
			api: null,
			dialogoPlanilla: false,
			dialogoDespacho: false,
			idPlanilla: null,
			itemHover: null,
			idViaje: null,
		}
	}
}
</script>
<style scoped>
.planilas-container {
	display: flex;
	flex-wrap: wrap;
}
.el-card {
	margin-bottom: 10px;
	margin-top: 10px;
	/* background: rgba(224, 213, 52, 0.05); */
	font: 13px Small;
	flex-basis: calc(50% - 13px);
	margin: 5px;
	/* width: 50%; */
}

.el-card:hover {
	background: rgba(0,0,0,0.05);
}

.el-divider {
	margin: 10px 0px;
}

label {
	font-weight: bold;
	width: 70px;
	display: inline-block;
}


.card {
	position: relative;
}


.buttons {
	position: absolute;;
	top: 5px;
	right: 5px;
	width: auto;
}



</style>
